<?php

require_once 'TestHelper.php';

/**
 * Zext_Service_Cdyne_ProfanityFilter test case.
 */
class Zext_Service_Cdyne_TestProfanityFilter extends PHPUnit_Framework_TestCase {
	
	/**
	 * @var Zext_Service_Cdyne_ProfanityFilter
	 */
	private $service;
	
	/**
	 * Prepares the environment before running a test.
	 */
	protected function setUp() {
		parent::setUp ();
		
		// TODO Auto-generated Zext_Service_Cdyne_TestProfanityFilter::setUp()
		

		$this->service = new Zext_Service_Cdyne_ProfanityFilter(/* parameters */);
	
	}
	
	/**
	 * Cleans up the environment after running a test.
	 */
	protected function tearDown() {
		// TODO Auto-generated Zext_Service_Cdyne_TestProfanityFilter::tearDown()
		

		$this->service = null;
		
		parent::tearDown ();
	}
	
	/**
	 * Constructs the test case.
	 */
	public function __construct() {
		// TODO Auto-generated constructor
	}
	
	/**
	 * Tests Zext_Service_Cdyne_ProfanityFilter->__construct()
	 */
	public function test__construct() {
		// TODO Auto-generated Zext_Service_Cdyne_TestProfanityFilter->test__construct()
		$this->markTestIncomplete ( "__construct test not implemented" );
		
		$this->service->__construct(/* parameters */);
	
	}
	
	public function testGetFunctions() {
		$functions = $this->service->getFunctions ();
		
		$expectedFunctions = array (0 => 'SimpleProfanityFilterResponse SimpleProfanityFilter(SimpleProfanityFilter $parameters)', 1 => 'ProfanityFilterResponse ProfanityFilter(ProfanityFilter $parameters)', 2 => 'AdvancedProfanityFilterResponse AdvancedProfanityFilter(AdvancedProfanityFilter $parameters)', 3 => 'GetReplaceTypesResponse GetReplaceTypes(GetReplaceTypes $parameters)', 4 => 'CreateUserDefinedKeyResponse CreateUserDefinedKey(CreateUserDefinedKey $parameters)', 5 => 'CreateProfanityLevelResponse CreateProfanityLevel(CreateProfanityLevel $parameters)', 6 => 'GetProfanityLevelsResponse GetProfanityLevels(GetProfanityLevels $parameters)', 7 => 'AddProfanityWordToLevelByKeyResponse AddProfanityWordToLevelByKey(AddProfanityWordToLevelByKey $parameters)', 8 => 'DeleteProfanityWordFromLevelByKeyResponse DeleteProfanityWordFromLevelByKey(DeleteProfanityWordFromLevelByKey $parameters)', 9 => 'GetKeysByLicenseKeyResponse GetKeysByLicenseKey(GetKeysByLicenseKey $parameters)', 10 => 'GetWordsByLevelResponse GetWordsByLevel(GetWordsByLevel $parameters)', 11 => 'DeleteProfanityLevelByKeyResponse DeleteProfanityLevelByKey(DeleteProfanityLevelByKey $parameters)', 12 => 'DeleteKeyByLicenseKeyResponse DeleteKeyByLicenseKey(DeleteKeyByLicenseKey $parameters)', 13 => 'AddWordToNonProfanityListByKeyResponse AddWordToNonProfanityListByKey(AddWordToNonProfanityListByKey $parameters)', 14 => 'DeleteWordFromNonProfanityListByKeyResponse DeleteWordFromNonProfanityListByKey(DeleteWordFromNonProfanityListByKey $parameters)', 15 => 'GetDefaultLevelsResponse GetDefaultLevels(GetDefaultLevels $parameters)', 16 => 'GetDefaultWordsByLevelResponse GetDefaultWordsByLevel(GetDefaultWordsByLevel $parameters)', 17 => 'SimpleProfanityFilterResponse SimpleProfanityFilter(SimpleProfanityFilter $parameters)', 18 => 'ProfanityFilterResponse ProfanityFilter(ProfanityFilter $parameters)', 19 => 'AdvancedProfanityFilterResponse AdvancedProfanityFilter(AdvancedProfanityFilter $parameters)', 20 => 'GetReplaceTypesResponse GetReplaceTypes(GetReplaceTypes $parameters)', 21 => 'CreateUserDefinedKeyResponse CreateUserDefinedKey(CreateUserDefinedKey $parameters)', 22 => 'CreateProfanityLevelResponse CreateProfanityLevel(CreateProfanityLevel $parameters)', 23 => 'GetProfanityLevelsResponse GetProfanityLevels(GetProfanityLevels $parameters)', 24 => 'AddProfanityWordToLevelByKeyResponse AddProfanityWordToLevelByKey(AddProfanityWordToLevelByKey $parameters)', 25 => 'DeleteProfanityWordFromLevelByKeyResponse DeleteProfanityWordFromLevelByKey(DeleteProfanityWordFromLevelByKey $parameters)', 26 => 'GetKeysByLicenseKeyResponse GetKeysByLicenseKey(GetKeysByLicenseKey $parameters)', 27 => 'GetWordsByLevelResponse GetWordsByLevel(GetWordsByLevel $parameters)', 28 => 'DeleteProfanityLevelByKeyResponse DeleteProfanityLevelByKey(DeleteProfanityLevelByKey $parameters)', 29 => 'DeleteKeyByLicenseKeyResponse DeleteKeyByLicenseKey(DeleteKeyByLicenseKey $parameters)', 30 => 'AddWordToNonProfanityListByKeyResponse AddWordToNonProfanityListByKey(AddWordToNonProfanityListByKey $parameters)', 31 => 'DeleteWordFromNonProfanityListByKeyResponse DeleteWordFromNonProfanityListByKey(DeleteWordFromNonProfanityListByKey $parameters)', 32 => 'GetDefaultLevelsResponse GetDefaultLevels(GetDefaultLevels $parameters)', 33 => 'GetDefaultWordsByLevelResponse GetDefaultWordsByLevel(GetDefaultWordsByLevel $parameters)' );
		
		$this->assertEquals ( $expectedFunctions, $functions );
	}
	
	public function testAdvancedProfanityFilterRemote() {
		$result = $this->service->advancedProfanityFilterRemote ( 'hell ass' );
		
		$expected = array ('found_profanity' => true, 'profanity_count' => 2, 'clean_text' => 'h*** a**' );
		
		$this->assertEquals ( $expected, $result );
	}
	
	public function testGetDefaultLevelsRemote() {
		$result = $this->service->getDefaultLevelsRemote ();
		
		$expected = array (10 => 'Inappropriate', 20 => 'Slang', 30 => 'Violence', 40 => 'Drug Related', 50 => 'General Cursing', 60 => 'Ethnic Hatred', 80 => 'Religious', 100 => 'Sexuality' );
		
		$this->assertEquals ( $expected, $result );
	}
	
	public function testGetDefaultWordsByLevelRemote() {
		$result = $this->service->getDefaultWordsByLevelRemote ( 10 );
		
		$this->assertGreaterThan ( 0, count ( $result ) );
		
		foreach ( $result as $filterWord ) {
			$this->assertTrue ( is_string ( $filterWord ) );
		}
	}
	
	public function testGetReplaceTypes() {
		$result = $this->service->getReplaceTypesRemote ();
		
		$expected = array (1 => array ('type_id' => 1, 'example' => '(s***, b****)', 'description' => 'Keeps the first character, but changes every other character after that with a *' ), 2 => array ('type_id' => 2, 'example' => '(***t, ****h)', 'description' => 'Keeps the last character, but every other character is replaced by *' ), 3 => array ('type_id' => 3, 'example' => '(sh*t, b*tch)', 'description' => 'Randomly picks a character to be replaced by *' ), 4 => array ('type_id' => 4, 'example' => '(**i*, *i***)', 'description' => 'Random picks a character to keep, all other characters are replaced by *' ), 5 => array ('type_id' => 5, 'example' => 'Your Own Text', 'description' => 'Every Profanity gets replaced by what you specify in the ReplaceProfanityText Field' ), 6 => array ('type_id' => 6, 'example' => '([ Explicited ])', 'description' => 'Default Replacement' ), 7 => array ('type_id' => 7, 'example' => '(s**t, b***h)', 'description' => 'Keeps first and last character, but everything else is replaced by *' ) );
		
		$this->assertEquals ( $expected, $result );
	}
	
	public function testProfanityFilterRemote() {
		$result = $this->service->profanityFilterRemote ( 'hell ass', 10 );
		
		$expected = array ('found_profanity' => true, 'profanity_count' => 2, 'clean_text' => '[Explicit] [Explicit]' );
		
		$this->assertEquals ( $expected, $result );
	}
	
	public function testSimpleProfanityFilterRemote() {
		$result = $this->service->simpleProfanityFilterRemote('hell ass');
		
		$expected = array ('found_profanity' => true, 'profanity_count' => 2, 'clean_text' => '[Explicit] [Explicit]' );
		
		$this->assertEquals ( $expected, $result );
	}
}

